unit AsyncDataReader;

interface

uses Classes, Windows, SysUtils, StdCtrls, IdTCPClient, StrUtils,
  Constants;

{ Classe per leggere in modo asincrono dati inviati dalla socket }

type
  TAsyncDataReader = class(TThread)
  private
    Socket: TIdTcpClient;
    Memo: TMemo;
    Running: boolean;
  public
    constructor Create(Memo: TMemo; Socket: TIdTcpClient);
    procedure Execute; override;
    procedure Stop;
  end;

implementation

{ Implementazione classe TAsyncDataReader }
constructor TAsyncDataReader.Create(Memo: TMemo; Socket: TIdTcpClient);
begin
  { Se siamo connessi esegui queste operazioni,
  altrimenti esci }
  if Socket.Connected then begin
    self.Memo := Memo;
    self.Socket := Socket;
    Running := true;
  end;
  inherited Create(false);
end;                                       
        
{ Entry point del thread }
procedure TAsyncDataReader.Execute;
var
  Response: string;
begin
  while Running do
  begin
    Sleep(10); //Per non intasare la cpu

    try
      Response := Socket.ReadLn;
    except
      Running := false;
    end;

    AppendStringTo(Response + #13,Memo);
  end;
end;

{ Esce dal thread }
procedure TAsyncDataReader.Stop;
begin
  Running := false;
end;



end.
