unit CopyDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TFrmCopy = class(TForm)
    ProgressBar: TProgressBar;
    AnimCopy: TAnimate;
    lblStatus: TLabel;
    lblPercent: TLabel;
  private
    TotBytes: integer;
    TransferedBytes: integer;

    procedure ShowBytesText;
    procedure ShowPercentage;
  public
    constructor Create(AOwner: TComponent);
    procedure SetTotBytes(TotBytes: integer);
    procedure SetTransferedBytes(TransferedBytes: integer);
  end;

var
  FrmCopy: TFrmCopy;

implementation

{ Costruttore }
constructor TFrmCopy.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  TotBytes := 0;
  TransferedBytes := 0;
  ProgressBar.Position := 0;
end;

{ Alcune propriet }
procedure TFrmCopy.SetTotBytes(TotBytes: integer);
begin
  self.TotBytes := TotBytes;
  self.Refresh;
end;
procedure TFrmCopy.SetTransferedBytes(TransferedBytes: integer);
begin
  self.TransferedBytes := TransferedBytes;
  ShowBytesText;
  ShowPercentage;
  lblStatus.Refresh;
  lblPercent.Refresh;
end;


{ Procedure utili }
procedure TFrmCopy.ShowBytesText;
begin
  lblStatus.Caption := IntToStr(TransferedBytes) + ' bytes of ' + IntToStr(TotBytes);
end;

procedure TFrmCopy.ShowPercentage;
var
  Perc: integer;
begin
  Perc := round((TransferedBytes / TotBytes) * 100);
  ProgressBar.Position := Perc;
  lblPercent.Caption := IntToStr(Perc) + '%';
end;


{$R *.dfm}

end.
