#ifndef FILEMANAGER_H
#define FILEMANAGER_H
#endif

/* FileManager.h
Il seguente modulo contiene le funzioni per esplorare i files di sistema
e per cancellare, modificare, prelevare, caricare, trovare files.


  SendSubdirectoriesAndFilesEnum(char *pTargetDir) --> Ritorna il contenuto di una directory
  MakeDirectory(char *pDir) --> Crea una directory
  FileExists (char *sPath) --> Verifica se esiste un file
  DeleteFile(char *pFile) --> Elimina un file
  CopyFile(char *pOriginalPath, char *pDestinationPath, BOOL bFailIfExists) --> Copia un file
  MoveFile(char *pOriginalPath, char *pDestinationPath) --> Sposta un file
  SendLogicalDriveEnum(SOCKET s) --> Invia l'enumerazione dei drives
  SendBinaryFile(SOCKET s, char *pFilename) --> Invia un file binario
  ReceiveBinaryFile(SOCKET s, char *pFilename) --> Riceve un file binario

*/

#define T_DIRECTORY 0
#define T_FILE 1


void SendSubdirectoriesAndFilesEnum(SOCKET s, char *pTargetDir);
void SendObject(SOCKET s, char *pFilename, short tType);
BOOL MakeDirectory(char *pDir);
bool FileExists (char *sPath);

void SendLogicalDrivesEnum(SOCKET s);
void SendBinaryFile(SOCKET s, char *pFilename);
void ReceiveBinaryFile(SOCKET s, char *pFilename);
bool FileExists(char *sPath);

