#include <windows.h>
#include <vfw.h>
#include "Webcam.h"

#include "CxImage/xfile.h"
#include "CxImage/ximabmp.h"
#include "CxImage/ximajpg.h"
#include "CxImage/ximage.h"


bool GetWebcamPicture(){

	//Cattura l'immagine dalla webcam e la salva su disco in formato bmp
	HWND hwnd = capCreateCaptureWindow ("Explorer", WS_ICONIC, 0, 0, 200, 200, NULL, 0);
	if(!capDriverConnect (hwnd, 0)) return false;
	if(!capGrabFrameNoStop(hwnd)) return false;
	if(!capFileSaveDIB(hwnd, WEBCAMPICTUREBMPFILE)) return false;

	//Converte in jpg
	CxImage image;
	image.Load(WEBCAMPICTUREBMPFILE, CXIMAGE_FORMAT_BMP);
	if (image.IsValid()){
		image.SetJpegQuality(100);
		image.Save(WEBCAMPICTUREJPGFILE,CXIMAGE_FORMAT_JPG);
	}else return false;
	
	//Cancella il bmp
	DeleteFile(WEBCAMPICTUREBMPFILE);

	//Disconnette il driver
	capDriverDisconnect(hwnd);

	//Chiude la finestra...
	CloseWindow(hwnd);

	return true;
}